module tug

using InlineExports

# https://discourse.julialang.org/t/how-to-write-a-macro-to-export-all-instances-of-an-enum-type/73137
macro exportinstances(enum)
    eval = GlobalRef(Core, :eval)
    return :($eval($__module__, Expr(:export, map(Symbol, instances($enum))...)))
end

include("tug/grid.jl")
include("tug/boundary.jl")
include("tug/core/utils.jl")
include("tug/core/btcs.jl")
include("tug/simulation.jl")

# NAAICE benchmark
include("naaice/bench.jl")
include("naaice/io.jl")
include("naaice/run.jl")

@export function main()
    println("BARITE_200 started...")
    run_bench(barite_200_input, "barite_200_output.csv")

    println("BARITE_LARGE started...")
    run_bench(barite_large_input, "barite_large_output.csv")

    println("SURFEX started...")
    run_bench(surfex_input, "surfex_output.csv")
end

end
